from django.test import TestCase

# Create your tests here.
from django.test.client import Client
from django.http import HttpResponse
from django.contrib.auth.models import User

import uuid

class ChangePasswordTest(TestCase):
    def setUp(self):
        self.client = Client()
        
        self.url = "/accounts/change_password"
        
        self.username: str = str(uuid.uuid4())
        self.password: str = str(uuid.uuid4())
        self.new_password: str = str(uuid.uuid4())
        
        User.objects.create_user(username = self.username, password = self.password)
        
    def test_normal(self):
        self.client.login(username = self.username, password = self.password)
        response: HttpResponse = self.client.post(self.url, {"current_password": self.password, "new_password": self.new_password})
        response_text: str = response.content.decode('utf-8')
        self.assertEqual(response_text, '"password changed"')
    
    def test_nologged(self):
        response: HttpResponse = self.client.post(self.url, {"current_password": self.password, "new_password": self.new_password})
        errors: dict = eval(response.content)
        self.assertDictEqual(errors, {'detail': 'Authentication credentials were not provided.'})